<div class="panel">
    <h3  class="font-medium mb-3 titulo">Artículos</h3>
    <h4  class="font-medium mb-3 subtitulo">Home - Artículos </h4>
    <div class="row">
        <div class="card col-12 panel-card" >
            <div class="row">
                <div class="col-10 d-flex align-items-center">
                    <label for="categoria" class="me-2">Categoría:</label>
                    <select class="form-select" (change)="gatArticulosCategoria()" [(ngModel)]="claveCategoria">
                        <option *ngFor="let categoria of categorias" [value]="categoria.clave">{{ categoria.nombre }}
                        </option>
                    </select>
                    <button type="button" class="btn btn-success" style="height: 36px; margin-left: 10px;"
                        (click)="showGuardar(true)">Agregar</button>

                </div>
                <div class="col-2 d-flex align-items-center justify-content-end">
                </div>
            </div>

            <div style="margin-top: 25px;">
                <table class="table table-hover">
                    <thead>
                        <tr>
                            <th>
                                Clave
                            </th>

                            <th>
                                Nombre
                            </th>
                            <th>
                                Categoria
                            </th>
                            <th>
                                Precios
                            </th>

                            <th>
                                Activo
                            </th>

                            <th>
                                Editar
                            </th>
                            <th>
                                Eliminar
                            </th>
                        </tr>


                    </thead>
                    <tbody>
                        <tr *ngFor="let articulo of articulosCategoria">
                            <td>{{articulo.clave}}</td>
                            <td>{{articulo.nombre}}</td>
                            <td>{{articulo.categoria.nombre}}</td>
                            <td>
                                <div *ngFor="let p of articulo.precios">
                                    {{p.precio | currency}}
                                </div>
                            </td>

                            <td>{{articulo.activo}}</td>
                            <td>
                                <button type="button" class="btn" style="height: 36px;"
                                    (click)="showActualizar(articulo)"> <i class="bi bi-pencil-fill"></i>
                                </button>
                            </td>
                            <td>
                                <button type="button" class="btn" style="height: 36px;"
                                    (click)="eliminar(articulo.id)"><i class="bi bi-trash"></i>
                                </button>
                            </td>
                        </tr>
                    </tbody>
                </table>
            </div>

        </div>
    </div>
</div>


<div id="mdlArticulos" class="modal fade" role="dialog"
    [ngStyle]="{'display': mdlSampleIsOpen ? 'block' : 'none', 'opacity': 1}">
    <div class="modal-backdrop fade" [ngClass]="{'show': mdlSampleIsOpen}"></div>

    <div class="modal-dialog modal-lg" style="margin-top: 10vh; z-index: 9999;">
        <div class="modal-content">
            <div class="modal-header">
                <h4 *ngIf="!esActualizacion" class="modal-title">Nuevo articulo</h4>
                <h4 *ngIf="esActualizacion" class="modal-title">Actualizar articulo</h4>

            </div>
            <div class="modal-body">

                <form [formGroup]="articuloForm" (ngSubmit)="onSubmit()">

                    <div class="form-group">
                        <label for="categoria">Categoría:</label>
                        <select class="form-select" formControlName="categoria">
                            <option *ngFor="let categoria of categorias" [value]="categoria.id">{{ categoria.nombre }}
                            </option>
                        </select>
                        <div *ngIf="articuloForm.get('categoria')?.invalid && articuloForm.get('categoria')?.touched"
                            class="text-danger">
                            La categoría es obligatoria.
                        </div>
                    </div>

                    <div class="form-group">
                        <label for="clave">Clave:</label>
                        <input type="text" class="form-control" formControlName="clave" />
                        <div *ngIf="articuloForm.get('clave')?.invalid && articuloForm.get('clave')?.touched"
                            class="text-danger">
                            La clave es obligatoria.
                        </div>
                    </div>



                    <div class="form-group">
                        <label for="nombre">Nombre:</label>
                        <input type="text" class="form-control" formControlName="nombre" />
                        <div *ngIf="articuloForm.get('nombre')?.invalid && articuloForm.get('nombre')?.touched"
                            class="text-danger">
                            El nombre es obligatorio.
                        </div>
                    </div>

                    <div formArrayName="precios">
                        <div *ngFor="let precio of preciosArray.controls; let i = index" class="d-flex align-items-center">
                            <div class="form-group flex-grow-1">
                                <label for="precio{{i}}">Precio {{i + 1}}:</label>
                                <input type="number" class="form-control" [formControlName]="i" />
                                <div *ngIf="precio.invalid && precio.touched" class="text-danger">
                                    El precio es obligatorio.
                                </div>
                            </div>
                           <div >
                            <button type="button" style="margin-top: 20px; margin-left: 20px;" (click)="quitarPrecio(i)" class="btn btn-danger"><i class="bi bi-trash"></i></button>
                            <button type="button" style="margin-top: 20px; margin-left: 10px;" (click)="agregarPrecio()" class="btn btn-primary"><i class="bi bi-plus"></i>
                            </button>

                           </div>
                        </div>
                    </div>
                    
                    <div class="d-flex justify-content-start">
                    </div>

                    <div class="form-group form-check">
                        <input type="checkbox" class="form-check-input" formControlName="activo" />
                        <label class="form-check-label" for="activo">Activo</label>
                        <div *ngIf="articuloForm.get('activo')?.invalid && articuloForm.get('activo')?.touched"
                            class="text-danger">
                            El producto debe estar activo.
                        </div>
                    </div>

                    <div class="d-flex justify-content-end">
                        <button (click)="this.mdlSampleIsOpen = false;"  style="margin-right: 10px;" class="btn btn-light">Cancelar</button>

                        <button *ngIf="!esActualizacion"  type="submit" class="btn btn-primary">Guardar</button>
                        <button *ngIf="esActualizacion"  (click)="actualizar()" class="btn btn-primary">Actualizar</button>
                    </div>
                </form>

            </div>
            <div class="modal-footer" align="right">
            </div>
        </div>
    </div>
</div>